--[[
	nowagepayment.lua
	--- IN DEVELOPMENT ---
	version: 0.1.1.0
	date: 21/12/12
	author: BigBlueHH
]]

NoWagePayment = {}
NoWagePayment.aiCostsPerRealHour = 1000
NoWagePayment.enteredVehicleIDs = {}

NoWagePayment.debug = false

function NoWagePayment.prerequisitesPresent(specializations)
	return true
end

function NoWagePayment.registerEventListeners(vehicleType)
	for _,n in pairs( { "onEnterVehicle","onLeaveVehicle" } ) do
		SpecializationUtil.registerEventListener(vehicleType, n, NoWagePayment)
	end
end

function NoWagePayment:loadMap(name)
	AIJob.getPricePerMs = Utils.overwrittenFunction(AIJob.getPricePerMs, NoWagePayment.getPricePerMs)
end

function NoWagePayment:onEnterVehicle()
	NoWagePayment.enteredVehicleIDs[self.id] = true
end

function NoWagePayment:onLeaveVehicle()
	NoWagePayment.enteredVehicleIDs[self.id] = nil
end

function NoWagePayment:getPricePerMs(superFunc)
	if NoWagePayment.enteredVehicleIDs[self.vehicleParameter.vehicleId] ~= nil then
		return 0
	else
		if NoWagePayment.aiCostsPerRealHour == 0 then
			return superFunc()
		else
			local pricePerMs = NoWagePayment.aiCostsPerRealHour/1000/60/60
			return pricePerMs
		end
	end	
end

addModEventListener(NoWagePayment)